// Right @ the beginning, sits in contended RAM @30000

#include "printer.h"

// And from 32768 onwards goes this...

// Phantomas Tales #4: Severin Sewers

#include <spritepack.h>

#pragma output STACKPTR=29999
#define AD_FREE			60000
#define VIEWPORT_X		1
#define VIEWPORT_Y		1
#define MAX_BLOBS		20

// RAM3

#define SCR_FRAME		49152
#define SCR_MOJON		49639
#define SCR_UBHRES		50000
#define SCR_MENU		51203
#define SCR_FINAL		52048
#define SCR_SHEET		53248

// Globals

struct sp_UDK keys;										// Keys structure.
void *joyfunc;											// Controls.
void *my_malloc(uint bytes) {return sp_BlockAlloc(0);}	// malloc routines
void *u_malloc = my_malloc;								// I wonder what
void *u_free = sp_FreeBlock;							// those do...
struct sp_SS *sp_player;								// Player sprites
struct sp_SS *sp_moviles [3];							// Enemy sprites
struct sp_Rect spritesClipValues;						// Clipping values
struct sp_Rect *spritesClip;							// Clipping rectangle
extern char asm_number[1];
extern unsigned int asm_int [1];
extern unsigned int asm_int_2 [1];
extern unsigned int seed [1];
unsigned char half_life;
unsigned int key_r;
unsigned char enoffs;

#asm
._asm_number 
	defb 0
._asm_int
	defw 0
._asm_int_2
	defw 0
._seed	
	defw 0
#endasm

// Modules

#include "128k.h"
#include "wyzplayer.h"
#include "aplib.h"
#include "menu.h"
#include "supertileset.h"
#include "tileset.h"
#include "spriteset.h"
#include "overlay.h"
#include "leveldata.h"
#include "levelstruct.h"
#include "engine.h"
 
// Main

void main (void) {
	unsigned char *allpurposepuntero;
	int j;
	unsigned char i;
	
	// Install ISR
	
	#asm
		di
	#endasm

	sp_InitIM2(0xf1f1);
	sp_CreateGenericISR(0xf1f1);
	sp_RegisterHook(255, ISR);
		
	#asm
		ei
	#endasm

	// Init splib2
	
	sp_Initialize (7, 0);
	sp_Border (BLACK);
	sp_AddMemory(0, 56, 14, AD_FREE);
	
	// Keys
	
	keys.up    = sp_LookupKey('q');
	keys.down  = sp_LookupKey('a');
	keys.left  = sp_LookupKey('o');
	keys.right = sp_LookupKey('p');
	keys.fire  = sp_LookupKey(' ');
	key_r = sp_LookupKey ('r');

	// Control scheme: default keyboard
		
	joyfunc = sp_JoyKeyboard;
	
	// Load tileset
		
	allpurposepuntero = tileset;
	for (j = 0; j <= 255; j++) {
		sp_TileArray (j, allpurposepuntero);
		allpurposepuntero += 8;
	}
	
	// Clipping rectangle

	spritesClipValues.row_coord = VIEWPORT_Y;
	spritesClipValues.col_coord = VIEWPORT_X;
	spritesClipValues.height = 18;
	spritesClipValues.width = 30;
	spritesClip = &spritesClipValues;
	
	// Create sprites
	
	sp_player = sp_CreateSpr (sp_MASK_SPRITE, 3, sprite_1_a, 1, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_1_b, TRANSPARENT);
	sp_AddColSpr (sp_player, sprite_1_c, TRANSPARENT);
	player.current_frame = player.next_frame = sprite_1_a;
	
	for (i = 0; i < 3; i ++) {
		sp_moviles [i] = sp_CreateSpr(sp_MASK_SPRITE, 3, sprite_9_a, 2, TRANSPARENT);
		sp_AddColSpr (sp_moviles [i], sprite_9_b, TRANSPARENT);
		sp_AddColSpr (sp_moviles [i], sprite_9_c, TRANSPARENT);	
		en_an [i].current_frame = en_an [i].next_frame = sprite_9_a;
	}
	
	// Intro
	
	play_music = 1;

	unpack_RAMn (3, SCR_MOJON, 16384, 1);
	wyz_play_sound (8, 2);
	espera_activa (150);
	unpack_RAMn (3, SCR_UBHRES, 16384, 1);
	wyz_play_sound (7, 2);
	espera_activa (150);
	unpack_RAMn (3, SCR_SHEET, 16384, 1);
	wyz_play_sound (5, 2);
	espera_activa (1000);
	
	blackout_everything ();
	draw_fast (10, 10, 70, "DEDICATED TO");
	draw_fast (9, 12, 71, "ENRIQ  CERVERA");
	draw_fast (8, 13, 71, "EMILIO SALGUEIRO");
	wyz_play_sound (6, 2);
	espera_activa (150);
	
	// Menu
	
	menu ();
}
